// ====================================================================
// Copyright (C) 2011 - Tsubasa Saito
//
// This file must be used under the terms of the CeCILL.
// This source file is licensed as described in the file COPYING, which
// you should have received as part of this distribution.  The terms
// are also available at
// http://www.cecill.info/licences/Licence_CeCILL_V2-en.txt
// ====================================================================

// *****************************************************************
// LU decomposition
//
// Calling Sequence :
// lu(A)
//
// Arguments :
// A : DD matrix
//
// Return :
// L : (n,n) lower triangular matrix
// U : (n,n) upper triangular matrix
//
// make dll file with Visual C++2010
//
// Authors :
// Copyright (C) 2011 - Tsubasa Saito
// last updating : 
// *****************************************************************
function [L,U] = %dd_lu(A)
  [m,n] = size(A.hi)
  if m~=n then
    disp('A is not square matrix.')
  else
    B=A;
    z=zeros(n,n);
    L = tlist(['dd','hi','lo'],eye(n,n),z);
    U = tlist(['dd','hi','lo'],z,z);
    for j=1:n
      for i=2:j
        for k=1:(i-1)
          B(i,j) = B(i,j) - B(i,k)*B(k,j);
        end
      end
      for i=(j+1):n
        for k=1:(j-1)
          B(i,j) = B(i,j) - B(i,k)*B(k,j);
        end
        B(i,j) = B(i,j) / B(j,j);
      end
    end
    for j=1:n
      U(1:j,j) = B(1:j,j);
      L((j+1):n,j) = B((j+1):n,j);
    end
  end
endfunction
