// ====================================================================
// Copyright (C) 2011 - Tsubasa Saito
//
// This file must be used under the terms of the CeCILL.
// This source file is licensed as described in the file COPYING, which
// you should have received as part of this distribution.  The terms
// are also available at
// http://www.cecill.info/licences/Licence_CeCILL_V2-en.txt
// ====================================================================

// *****************************************************************
// Inner product of DD numbers
//
// Calling Sequence :
// ddip(x,y)
//
// Arguments :
// x,y : DD vectors
//
// Authors :
// Copyright (C) 2011 - Tsubasa Saito
// last updating : 
// *****************************************************************
function z = ddip(x,y)
  //inner product
  [m1,n1] = size(x.hi);
  [m2,n2] = size(y.hi);
  if n1 ~= 1 | n2 ~=1 | m1 ~= m2 then
    disp('Error in  ddip!');
    z = tlist(['dd','hi','lo'],0,0);
  else
    t = 134217729 * x.hi;
    ah = t - (t - x.hi);
    al = x.hi - ah;
    
    t = 134217729 * y.hi;
    bh = t - (t - y.hi);
    bl = y.hi - bh;
    
    p1 = x.hi .* y.hi;
    p2 = ((ah .* bh - p1) + ah .* bl + al .* bh) + al .* bl;
    
    p2 = p2 + x.hi .* y.lo;
    p2 = p2 + x.lo .* y.hi;
      
    chi = p1 + p2;
    clo = p2 - (chi - p1);
    
    for k=2:m1
      sh = chi(k-1) + chi(k);
      v = sh - chi(k-1);
      eh = (chi(k-1) - (sh - v)) + (chi(k) - v);
      
      sl = clo(k-1) + clo(k);
      eh = eh + sl;
      chi(k) = sh + eh;
      clo(k) = eh - (chi(k) - sh);
    end
  z = tlist(['dd','hi','lo'],chi(m1),clo(m1));
  end
endfunction

