// ====================================================================
// Copyright (C) 2011 - Tsubasa Saito
//
// This file must be used under the terms of the CeCILL.
// This source file is licensed as described in the file COPYING, which
// you should have received as part of this distribution.  The terms
// are also available at
// http://www.cecill.info/licences/Licence_CeCILL_V2-en.txt
// ====================================================================

// *****************************************************************
// Inner product of QD numbers
//
// Calling Sequence :
// qdip(x,y)
//
// Arguments :
// x,y : QD vectors
//
// Authors :
// Copyright (C) 2011 - Tsubasa Saito
// last updating : 
// *****************************************************************
function z = qdip(x,y)
  [m1,n1] = size(x.d);
  [m2,n2] = size(y.d);
  if n1 ~= 1 | n2 ~=1 | m1 ~= m2 then
    disp('Error in  qdip!');
    z = tlist(['qd','d'],0,0,0,0);
  else
    z = tlist(['qd','d'],0,0,0,0);
    for i=1:m1
      z = z + x(i,1)*y(i,1);
    end
  end
endfunction

