// ====================================================================
// Copyright (C) 2011 - Tsubasa Saito
//
// This file must be used under the terms of the CeCILL.
// This source file is licensed as described in the file COPYING, which
// you should have received as part of this distribution.  The terms
// are also available at
// http://www.cecill.info/licences/Licence_CeCILL_V2-en.txt
// ====================================================================

// *****************************************************************
// Frobenius norm of QD matrix
//
// Calling Sequence :
// ddnormF(A)
//
// Arguments :
// A : QD matrix
//
// Authors :
// Copyright (C) 2011 - Tsubasa Saito
// last updating : 
// *****************************************************************
function z = qdnormF(A)
  [m,n] = size(A.d);
  X = A;
  c = find(sign(X.hi)==-1);
      X(2)(c) = (-1)*X(2)(c);
      X(3)(c) = (-1)*X(3)(c);
      X(4)(c) = (-1)*X(4)(c);
      X(5)(c) = (-1)*X(5)(c);
      z = tlist(['qd','d'],0,0,0,0);
      for i=1:m
        for j=1:n
          z = z + X(i,j);
        end
      end
endfunction
